import { NgModule } from '@angular/core';
import { NavigationEnd, Router, RouterModule } from '@angular/router';
import { SubappComponent } from './subapp/subapp.component';
import { DictionaryTypeComponent } from './dictionarytype/dictionarytype.component';
import { DictionaryComponent } from './dictionary/dictionary.component';
import { RackTypeComponent } from './racktype/racktype.component';
import { RackAreaComponent } from './rackarea/rackarea.component';
import { RackIdComponent } from './rackid/rackid.component';
import { RoleInterfaceComponent } from './roleinterface/roleinterface.component';
import { WaferTraceReportComponent } from './waferTraceReport/waferTraceReport.component';
import { WaferAreaComponent } from './waferarea/waferarea.component';
import { WaferAreaFlowComponent } from './waferareaflow/waferareaflow.component';
import { WaferSendOutComponent } from './wafersendout/wafersendout.component';
import { WaferCancelSendComponent } from './wafercancelsend/wafercancelsend.component';
import { WaferReceiveComponent } from './waferreceive/waferreceive.component';
import { WaferSelectComponent } from './waferselect/waferselect.component';
import { AbnormalReportComponent } from './abnormalreport/abnormalreport.component';
import { CheckReportComponent } from './checkreport/checkreport.component';
import { RuncardsystemComponent } from './runcardsystem/runcardsystem.component';

@NgModule({
    imports: [
        RouterModule.forChild([
            {
                path: '',
                children: [
                    { path: 'subapp', component: SubappComponent, data: { permission: 'Pages.Basic.SubApp' } },
                    { path: 'dictionarytype', component: DictionaryTypeComponent, data: { permission: 'Pages.DictionaryTypes' } },
                    { path: 'dictionary', component: DictionaryComponent, data: { permission: 'Pages.Dictionary' } },
                    { path: 'racktype', component: RackTypeComponent },
                    { path: 'rackarea', component: RackAreaComponent },
                    { path: 'rackid', component: RackIdComponent },
                    { path: 'roleinterface', component: RoleInterfaceComponent},
                    { path: 'waferreport', component: WaferTraceReportComponent},
                    { path: 'waferarea', component: WaferAreaComponent},
                    { path: 'waferareaflow', component: WaferAreaFlowComponent},
                    { path: 'wafersendout', component: WaferSendOutComponent},
                    { path: 'wafercancelsend', component: WaferCancelSendComponent},
                    { path: 'waferreceive', component: WaferReceiveComponent},
                    { path: 'waferselect', component: WaferSelectComponent},
                    { path: 'abnormalreport', component: AbnormalReportComponent },
                    { path: 'checkreport', component: CheckReportComponent },
                    { path: 'runcardsystem', component: RuncardsystemComponent}
                ]
            }
        ])
    ],
    exports: [
        RouterModule
    ]
})
export class BasicRoutingModule {
        constructor(
            private router: Router
        ) {
            router.events.subscribe((event) => {
                if (event instanceof NavigationEnd) {
                    window.scroll(0, 0);
                }
            });
        }
}

