import { Component, EventEmitter, Injector, Output, ViewChild } from '@angular/core';
import { AppComponentBase } from '@shared/common/app-component-base';
import { ModalDirective } from 'ngx-bootstrap';
import { DomSanitizer } from '@angular/platform-browser';
import { FormGroup } from '@angular/forms';
import { WaferHttp } from '@app/shared/common/utils/waferhttp.service';

@Component({
    selector: 'waferHistoryModal',
    templateUrl: './waferhistory-modal.component.html'
})
export class WaferHistoryModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal') modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();
    active = false;
    saving = false;
    uploadUrl: string;
    exCallForm: FormGroup;
    imageChangedEvent: any = '';
    subAppIconId: string;
    isEdit = false;
    waferId: string;
    constructor(
        injector: Injector, public sanitizer: DomSanitizer,
        private waferHttp: WaferHttp
    ) {
        super(injector);
    }
    show(subAppId?: string): void {
        this.waferId = subAppId;
        const self = this;
        self.active = true;
        let data = {
            waferId: subAppId
        };
        this.waferHttp.get('api/WaferTraceManage/GetWaferHistory', data, res => {
            //this.primengTableHelper.records = JSON.parse(res.result);
            this.primengTableHelper.records = res;
        });
        self.modal.show();
    }

    close(): void {
        this.modal.hide();
    }
}
