import { Component, Injector, ViewChild, OnInit } from '@angular/core';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { SubAppServiceProxy, SubAppDto, RackTypeServiceProxy, WaferAreaServiceProxy } from '@shared/service-proxies/service-proxies';
import { Table } from 'primeng/components/table/table';
import * as _ from 'lodash';
import { LazyLoadEvent } from 'primeng/api';
import { Paginator } from 'primeng/primeng';
import { FileDownloadService } from '@shared/utils/file-download.service';
import { SelfHttp } from '@app/shared/common/utils/selfHttp.service';
import { WaferHttp } from '@app/shared/common/utils/waferhttp.service';
import { WaferAreaLookupTableModalComponent } from '@app/shared/lookup/waferAreaLookup/waferArea-lookup-table-modal.component';
import { WaferAreaSerarchInputDto } from '../waferarea/waferarea.model';
import { GetWaferForViewDto } from '../wafersendout/wafersendout.model';

@Component({
    templateUrl: './waferselect.component.html',
    animations: [appModuleAnimation()]
})
export class WaferSelectComponent extends AppComponentBase implements OnInit {

    @ViewChild('dataTable') dataTable: Table;
    @ViewChild('paginator') paginator: Paginator;
    @ViewChild('waferAreaLookupTableModal') waferAreaLookupTableModal: WaferAreaLookupTableModalComponent;
    advancedFiltersAreShown = false;

    //Filters
    filterText = '';
    code = '';
    controllot = '';
    waferAreaSerarchInputDto = new WaferAreaSerarchInputDto();
    selectWafers: Array<GetWaferForViewDto> = new Array<GetWaferForViewDto>();
    fromCode: string;
    toCode: string;
    selectArea: string;
    checklocation: string;

    constructor(
        injector: Injector,
        private _waferAreaService: WaferAreaServiceProxy,
        private _fileDownloadService: FileDownloadService,
        private waferHttp: WaferHttp
    ) {
        super(injector);
    }

    ngOnInit(): void {
    }

    getAll(): void {
        let data = {
            filter: this.filterText
        };
        if (this.filterText === '') {
            this.message.error('扫入资料不能为空!');
            return;
        }
        this.waferHttp.get('api/WaferTraceManage/WaferSelect', data, res => {
            //this.primengTableHelper.records = JSON.parse(res.result);
            this.primengTableHelper.records = res;
            if (res.length > 0) {
                this.checklocation = res[0].LOCATION;
            } else {
                this.message.error('扫入资料无发料信息!');
            }
        });
    }
    close() {

    }
}
